# To do 

## Critical

- [ ] Engine default management (stateid + userid)
 
  as a common storage is a bad architecture choice (possible bugs  in time delayed transactions, in a multiuser scenario). 
  It must be replaced asap.


## Architectural improvements

- [ ] synchronous/asynchronous state handlers
 
  A special note concerns the synchronous/asynchronous behaviors of nodejs. 
  Currently input and output state handlers are normal "synchronous" javascript functions. 
  That's debatable. 

  > If NaifJs run as a server in a multi user context, for delayed/promised/timeout functions 
  > (anything that will run out-of-time in a future (~promise), 
  > please remember to pass the *id* (*session id* / *user id*) to functions that will be activated with a time delay.

- [ ] sessions database
 
  Currently the sessions are managed as in-memory hash table (a javascript object), 
  read from disk at up time and persisted to disk on down time.
  A better choice is to decouple sessions into a separate database (e.g. using REDIS, or LMDB, or any other DB).  

## APIs

- [ ] Default timeout handler

  NaifJs could supply a default response timeout handler, that ask every M seconds the last prompt P. 

- [ ] Prompts timeout data management 
 
  So far, timeout handlers are managed in a dedicated in-memory object. 
  Not a perfect choice. Maybe would be part of the session object.

- [ ] Default timeout handler

  NaifJs could supply a default response timeout handler, that ask every M seconds the last prompt P. 

- [ ] Debugging features to be added in `naif test` 


## Naif test 

On return keystroke, the command line program must be enabled by inline commands for debug purposes,
maybe using a special prefix e.g. `/command` `:command`, to show:

 - stateid
 - the dialog flow stateids stack [state1 -> state2-> state3 -> etc.] 
 - dialog unit variables 
 - all session data

## Graphic representation of the state-machines / scripting language "transpilations"

- [ ] state-machine graphic representation

  - output: think about how generate (in real-time) a graphic representation of the state machine path flow. 
  - input: it could be useful to generate state machine code, starting from a graphical representation of a state machine. 

- [ ] scripting language transpilation
 
  How to create a dialogue javascript source code from a JSON file or better, 
  a text script with a special indentation and meta-tags (like the .script). And viceversa.


## Other things 

- [ ] Add more meaningful/complete application examples 

  e.g. task completion, see *promemoria*, slot-filling, see *conosciamoci*, etc.

- [ ] Regexp pattern matching implementation must be rethought. 

- [ ] Enable NaifJs run-time to run on a browser

  Session file must be substituted with a in-memory storage.

- [ ] Log management 
 
  currently optional for `naif test` and  `naif telegram` is ugly implemented. 
  It must be fixed.

- [ ] `naif server`

  New feature: the idea is to wrap NaifJs engine behind a HTTP/TCP server.


---

[top](#) | [home](../README.md)

